//===================================================================
// Apci8308w.c - wrapper for C/C++
//-------------------------------------------------------------------
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#include <windows.h>
#include <tchar.h>

#include "Apci8308w.h"

static BOOL	   _Apci8308wGetDllExportFunc( void );
static HMODULE hDLL = NULL;

static FARPROC pApci8308GetVersion;
static FARPROC pApci8308Create;
static FARPROC pApci8308Close;
static FARPROC pApci8308GetResource;
static FARPROC pApci8308GetSwitchValue;
static FARPROC pApci8308GetLastError;
static FARPROC pApci8308SioStart;
static FARPROC pApci8308SioGetStatus;
static FARPROC pApci8308SioRead;
static FARPROC pApci8308SioWrite;
static FARPROC pApci8308SioReset;
static FARPROC pApci8308SioStop;

//===================================================================
//   		DLL [h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci8308wDllOpen( void )
{
	if ( hDLL != NULL ) return FALSE;
	hDLL = (HMODULE)LoadLibrary(APCI8308_DLL_NAME);
	if ( hDLL == NULL ) return FALSE;
	if ( _Apci8308wGetDllExportFunc() == FALSE ) {
		Apci8308wDllClose();
		return FALSE;
	}
	return TRUE;
}
//===================================================================
//   		DLL A[h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci8308wDllClose( void )
{
	if ( hDLL == NULL ) return FALSE;
	if ( FreeLibrary(hDLL) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//===================================================================
//   		DLL,Driver ̃o[W擾
//   		pdwDllVer			DLL o[Wԍi[̈
//				pdwDrvVer			DRV o[Wԍi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wGetVersion( PDWORD pdwDllVer, PDWORD pdwDrvVer )
{
	if ( hDLL == NULL ) return APCI8308_ERR_WRAPDLL;
	return (*pApci8308GetVersion)(pdwDllVer, pdwDrvVer);
}
//===================================================================
//   		foCXgp錾
//   		pwLogSlot				gpfoCXԍi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wCreate( PWORD pwLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308Create)(pwLogSlot);
}
//===================================================================
//   		foCXJ
//   		wLogSlot				foCX̘_Xbgԍ
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wClose( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308Close)(wLogSlot);
}
//===================================================================
//   		\[X擾
//   		wLogSlot				foCX̘_Xbgԍ
//				pRes					\[Xi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wGetResource( WORD wLogSlot, PAPCI8308R pRes )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308GetResource)(wLogSlot,pRes);
}
//===================================================================
//   		arml擾
//   		wLogSlot				foCX̘_Xbgԍ
//				pdwSwitchValue			armli[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wGetSwitchValue( WORD wLogSlot, PDWORD pdwSwitchValue )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308GetSwitchValue)(wLogSlot,pdwSwitchValue);
}
//===================================================================
//   		G[擾
//   		wLogSlot				foCX̘_Xbgԍ
// ߂l		G[
//===================================================================
DWORD Apci8308wGetLastError( WORD wLogSlot )
{
	if ( hDLL == NULL ) return APCI8308_ERR_WRAPDLL;
	return (*pApci8308GetLastError)(wLogSlot);
}
//===================================================================
//   		VAʐMJn
//   		wLogSlot				foCX̘_Xbgԍ
//				wCh						gp`l
//				pMode					샂[hi[Ă̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wSioStart( WORD wLogSlot, WORD wCh, PSIOMODE pMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308SioStart)(wLogSlot,wCh,pMode);
}
//===================================================================
//   		ʐMXe[^X擾
//   		wLogSlot				foCX̘_Xbgԍ
//				wCh						gp`l
//				pStatus					Xe[^Xi[̈
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wSioGetStatus( WORD wLogSlot, WORD wCh, PSIOSTATUS pStatus )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308SioGetStatus)(wLogSlot,wCh,pStatus);
}
//===================================================================
//   		f[^M
//   		wLogSlot				foCX̘_Xbgԍ
//				wCh						gp`l
//				pbData					Mf[^ۑ̈
//				dwDataSize				Mf[^
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wSioRead( WORD wLogSlot, WORD wCh, PBYTE pbData, DWORD dwDataSize )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308SioRead)(wLogSlot,wCh,pbData,dwDataSize);
}
//===================================================================
//   		f[^M
//   		wLogSlot				foCX̘_Xbgԍ
//				wCh						gp`l
//				pbData					Mf[^̈
//				dwDataSize				Mf[^
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wSioWrite( WORD wLogSlot, WORD wCh, PBYTE pbData, DWORD dwDataSize )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308SioWrite)(wLogSlot,wCh,pbData,dwDataSize);
}
//===================================================================
//   		obt@̃Zbg
//   		wLogSlot				foCX̘_Xbgԍ
//				wCh						gp`l
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wSioReset( WORD wLogSlot, WORD wCh )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308SioReset)(wLogSlot,wCh);
}
//===================================================================
//   		VAʐM~
//   		wLogSlot				foCX̘_Xbgԍ
//				wCh						gp`l
// ߂l		 TRUE
//				s FALSE
//===================================================================
BOOL Apci8308wSioStop( WORD wLogSlot, WORD wCh )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci8308SioStop)(wLogSlot,wCh);
}
//-------------------------------------------------------------------
// 			DLL߰Ċ֐ڽ̎擾
// 			
// ߂l		 TRUE
//				s FALSE
//-------------------------------------------------------------------
static BOOL _Apci8308wGetDllExportFunc( void )
{
	pApci8308GetVersion		= GetProcAddress(hDLL, _T("Apci8308GetVersion"));
	pApci8308Create			= GetProcAddress(hDLL, _T("Apci8308Create"));
	pApci8308Close			= GetProcAddress(hDLL, _T("Apci8308Close"));
	pApci8308GetResource	= GetProcAddress(hDLL, _T("Apci8308GetResource"));
	pApci8308GetSwitchValue	= GetProcAddress(hDLL, _T("Apci8308GetSwitchValue"));
	pApci8308GetLastError	= GetProcAddress(hDLL, _T("Apci8308GetLastError"));
	pApci8308SioStart		= GetProcAddress(hDLL, _T("Apci8308SioStart"));
	pApci8308SioGetStatus	= GetProcAddress(hDLL, _T("Apci8308SioGetStatus"));
	pApci8308SioRead		= GetProcAddress(hDLL, _T("Apci8308SioRead"));
	pApci8308SioWrite		= GetProcAddress(hDLL, _T("Apci8308SioWrite"));
	pApci8308SioReset		= GetProcAddress(hDLL, _T("Apci8308SioReset"));
	pApci8308SioStop		= GetProcAddress(hDLL, _T("Apci8308SioStop"));

	if ( pApci8308GetVersion == NULL )		return FALSE;
	if ( pApci8308Create == NULL )			return FALSE;
	if ( pApci8308Close == NULL )			return FALSE;
	if ( pApci8308GetResource == NULL )		return FALSE;
	if ( pApci8308GetSwitchValue == NULL )	return FALSE;
	if ( pApci8308GetLastError == NULL )	return FALSE;
	if ( pApci8308SioStart == NULL )		return FALSE;
	if ( pApci8308SioGetStatus == NULL )	return FALSE;
	if ( pApci8308SioRead == NULL )			return FALSE;
	if ( pApci8308SioWrite == NULL )		return FALSE;
	if ( pApci8308SioReset == NULL )		return FALSE;
	if ( pApci8308SioStop == NULL )			return FALSE;

	return TRUE;
}